ed989498dbd7df7e7ed2b1b2ab94fe7e1cdb1da9
[lttng-tools.git] / tests / stress / test_multi_sessions_per_uid_5app_streaming
1 #!/bin/bash
2 #
3 # Copyright (C) - 2013 David Goulet <dgoulet@efficios.com>
4 #
5 # This library is free software; you can redistribute it and/or modify it under
6 # the terms of the GNU Lesser General Public License as published by the Free
7 # Software Foundation; version 2.1 of the License. details.
8 #
9 # You should have received a copy of the GNU Lesser General Public License
10 # along with this library; if not, write to the Free Software Foundation, Inc.,
11 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
12
13 CURDIR=$(dirname $0)/
14 TESTDIR=$CURDIR/..
15 LAUNCH_APP="launch_ust_app"
16 SESSION_NAME="stress"
17 EVENT_NAME="tp:tptest"
18 LOG_FILE_SESSIOND="sessiond.log"
19 LOG_FILE_RELAYD="relayd.log"
20 CHANNEL_NAME="channel0"
21 NR_APP=5
22 NR_SESSION=5
23 NR_LOOP=1000
24 COREDUMP_FILE=$(cat /proc/sys/kernel/core_pattern)
25 NUM_TESTS=16
26 APPS_PID=
27
28 TEST_DESC="Stress test - $NR_SESSION sessions per UID streaming with $NR_APP apps"
29
30 source $TESTDIR/utils/utils.sh
31
32 # MUST set TESTDIR before calling those functions
33
34 function enable_channel_per_uid()
35 {
36 local sess_name=$1
37 local channel_name=$2
38
39 $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel --buffers-uid -u $channel_name -s $sess_name >/dev/null 2>&1
40 ok $? "Enable channel $channel_name per UID for session $sess_name"
41 }
42
43 function check_sessiond()
44 {
45 if [ -z "$(pgrep --full lt-lttng-sessiond)" ]; then
46 local str_date=$(date +%H%M%S-%d%m%Y)
47
48 diag "!!!The session daemon died unexpectedly!!!"
49 mv $LOG_FILE_SESSIOND $LOG_FILE_SESSIOND-$str_date
50 if [ -e $COREDUMP_FILE ]; then
51 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
52 fi
53 exit 1
54 fi
55 }
56
57 function check_relayd()
58 {
59 if [ -z "$(pgrep --full lt-lttng-relayd)" ]; then
60 local str_date=$(date +%H%M%S-%d%m%Y)
61
62 diag "!!!The relay daemon died unexpectedly!!!"
63 mv $LOG_FILE_RELAYD $LOG_FILE_RELAYD-$str_date
64 if [ -e $COREDUMP_FILE ]; then
65 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
66 fi
67 exit 1
68 fi
69 }
70
71 function start_sessiond()
72 {
73 validate_kernel_version
74 if [ $? -ne 0 ]; then
75 fail "Start session daemon"
76 BAIL_OUT "*** Kernel too old for session daemon tests ***"
77 fi
78
79 if [ -z $(pgrep --full lt-$SESSIOND_BIN) ]; then
80 # We have to start it like this so the ulimit -c is used by this
81 # process. Also, we collect any error message printed out.
82 $TESTDIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --quiet --background --consumerd32-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" >$LOG_FILE_SESSIOND 2>&1
83 status=$?
84 ok $status "Start session daemon"
85 fi
86 }
87
88 function start_relayd
89 {
90 local opt=$1
91
92 if [ -z $(pgrep --full lt-$RELAYD_BIN) ]; then
93 $TESTDIR/../src/bin/lttng-relayd/$RELAYD_BIN $opt >$LOG_FILE_RELAYD 2>&1 &
94 ok $? "Start lttng-relayd (opt: \"$opt\")"
95 fi
96 }
97
98 test_stress()
99 {
100 for b in $(seq 1 $NR_LOOP); do
101 for a in $(seq 1 $NR_SESSION); do
102 create_lttng_session_uri $SESSION_NAME-$a net://localhost
103 check_sessiond
104 check_relayd
105 enable_channel_per_uid $SESSION_NAME-$a $CHANNEL_NAME
106 check_sessiond
107 check_relayd
108 enable_ust_lttng_event_ok $SESSION_NAME-$a $EVENT_NAME
109 check_sessiond
110 check_relayd
111 start_lttng_tracing_ok $SESSION_NAME-$a
112 check_sessiond
113 check_relayd
114 done
115
116 for a in $(seq 1 $NR_SESSION); do
117 stop_lttng_tracing_ok $SESSION_NAME-$a
118 check_sessiond
119 check_relayd
120 destroy_lttng_session_ok $SESSION_NAME-$a
121 check_sessiond
122 check_relayd
123 done
124 done
125
126 return 0
127 }
128
129 function cleanup()
130 {
131 diag "Cleaning up!"
132 for p in ${APPS_PID}; do
133 kill -s SIGKILL ${p}
134 wait ${p} 2>/dev/null
135 done
136 APPS_PID=
137 stop_lttng_sessiond
138 stop_lttng_relayd
139 }
140
141 function sighandler()
142 {
143 cleanup
144 rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
145 exit 1
146 }
147
148 trap sighandler SIGINT
149 trap sighandler SIGTERM
150
151 # Make sure we collect a coredump if possible.
152 ulimit -c unlimited
153
154 # MUST set TESTDIR before calling those functions
155 plan_tests $NUM_TESTS
156
157 print_test_banner "$TEST_DESC"
158
159 TRACE_PATH=$(mktemp -d)
160
161 start_relayd "-o $TRACE_PATH"
162 start_sessiond
163
164 diag "Starting applications launcher"
165
166 # Start NR_APP applications script that will spawn apps non stop.
167 ./$TESTDIR/stress/$LAUNCH_APP $NR_APP &
168 APPS_PID="${APPS_PID} ${!}"
169
170 test_stress
171 out=$?
172 if [ $out -ne 0 ]; then
173 cleanup
174 exit $out
175 fi
176
177 cleanup
178 rm -rf $TRACE_PATH
179 rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
180 exit 0
This page took 0.034888 seconds and 5 git commands to generate.